Description

Currently, some assets are manually inserted into `vendor/assets` and not automatically updated, while others are added as gem

files which do update automatically but require additional packaging work every time they change.

It would be beneficial to use bower to maintain those assets for the following reasons:

1. Reduce packaging work.

2. Allow more frequent updates of included assets, as updates will not require separate repackaging.

3. Allow simple updates to assets which don't have a gemified version.

4. Allow timely updates to assets who's gemified versions are not up to date.

Related issues:

Related to Foreman - Bug #16046: "Don't know how to build task 'webpack:compi... Closed 08/10/2016

Related to Foreman - Bug #16074: development version listens on 0.0.0.0:3000 ... Closed 08/11/2016

Related to Foreman - Feature #16160: Add shell script to start foreman-webpack Closed 08/18/2016

Related to Foreman - Bug #17236: webpack source maps do not work Closed 11/06/2016

Related to Discovery - Bug #19403: js error of missing jquery.cookie Closed 04/27/2017

Associated revisions

Revision e2a57bfe - 08/10/2016 06:18 AM - Tomer Brisker

Fixes #12364 - Use NPM+Webpack to handle external assets

This commit introduces NPM and Webpack to handle external assets.

It also provides ES6 support and a live reload dev server that can be

used by running `foreman start` instead of `rails start`.

Do not forget to run `npm install` before starting the server.

This commit also contains some code that was created by Ohad Levy

<ohadlevy@gmail.com>

Revision 42ba771c - 08/11/2016 09:35 AM - Tomer Brisker

Refs #12364 - Allow running webpack dev server on any hostname

Currently, SecureHeaders only allows running the webpack dev server from

localhost or 0.0.0.0, and only using http. This leads to issues when

attempting to run foreman inside a virtual machine or using https. This

patch will generate the correct headers during runtime, to allow the dev

server to be run on the same host and protocol as the request uses.

Revision 31bbcd81 - 08/15/2016 11:14 AM - Tomer Brisker

Refs #12364 - Only load the dev server js if it's enabled
Also allow disabling the dev server from the settings file

Revision ab5c7c28 - 08/17/2016 04:43 AM - Marek Hulán

Refs #12364 - webpack server can serve assets on https

History

#1 - 11/13/2015 04:13 PM - Tomer Brisker

It would seem that bower is no longer being actively developed

So it would seem we should look into other options for handling assets, possibly npm.

#2 - 06/08/2016 04:53 AM - Tomer Brisker

- Subject changed from Use bower to maintain external assets (js, css, fonts) to Use NPM+Webpack to manage external assets (js, css, fonts)

- Status changed from New to Assigned

Changed this to NPM+Webpack following discussion in https://github.com/theforeman/rfcs/pull/3

#3 - 06/08/2016 05:33 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/3433 added

#4 - 07/29/2016 12:47 PM - Daniel Lobato Garcia

- Target version set to 1.7.1

#5 - 08/08/2016 10:37 AM - Daniel Lobato Garcia

- Target version deleted (1.7.1)

#6 - 08/08/2016 10:43 AM - Daniel Lobato Garcia

- Target version set to 1.7.1

#7 - 08/10/2016 07:01 AM - Tomer Brisker

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e2a57bfe537f7a5f1ef6aca7087df2f1fdea5905.

#8 - 08/10/2016 07:02 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#9 - 08/10/2016 07:11 AM - Dominic Cleal

- Related to Bug #16046: "Don't know how to build task 'webpack:compile'" running jenkins:integration task added

#10 - 08/11/2016 04:51 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/3721 added

#11 - 08/11/2016 10:49 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/3722 added

#12 - 08/12/2016 02:59 AM - Dominic Cleal

- Related to Bug #16074: development version listens on 0.0.0.0:3000 and 0.0.0.0:3808 by default added

#13 - 08/16/2016 07:04 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/3734 added

#14 - 08/18/2016 04:58 AM - Lukas Zapletal

- Related to Feature #16160: Add shell script to start foreman-webpack added
#15 - 08/23/2016 10:01 AM - Daniel Lobato Garcia

- Target version changed from 1.7.1 to 1.6.2

#16 - 08/23/2016 11:10 AM - Daniel Lobato Garcia

- Target version changed from 1.6.2 to 1.7.1

#17 - 11/06/2016 04:41 AM - Ohad Levy

- Related to Bug #17236: webpack source maps do not work added

#18 - 04/27/2017 04:58 AM - Ohad Levy

- Related to Bug #19403: js error of missing jquery.cookie added
